//+------------------------------------------------------------------+
//|                                                mql5tuto03dva.mq5 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Reunisoft Financials France"
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <Trade\AccountInfo.mqh>
#include <Trade\Trade.mqh>
#include <Charts\Chart.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
CAccountInfo ca;

int OnInit()
  {
//--- create timer
   //MessageBox("OnInit");
   //EventSetTimer(2);

   Print("Current Login = " + ca.Login());
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   //MessageBox("OnDeinit:reason=" + reason);
   //Alert("OnDeinit:reason=" + reason);
   //Print("OnDeinit:reason="+reason);
   Print("Closing all trades");
   CTrade trade;
   int i=PositionsTotal()-1;
   while (i>=0)
   {
      if (trade.PositionClose(PositionGetSymbol(i))) i--;
   }
   //EventKillTimer(); 
  }

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
int currentTick = 0;
int maxTickBeforeForceSell = 2000;
CTrade trade;
double balanceBeforeTrade = 0;
double balanceAfterTrade = 0;
double totalProfit = 0;
double initialBuyPrice = 0;
double initialSellPrice = 0;
double currentSellPrice = 0;
double currentBuyPrice = 0;
bool previousActionIsBuySellWithoutProfit = false;
double quantity = 0.1;

void OnTick()
  {
      //CChart cc;
      //Print(cc.Symbol());
      double currentProfit = 0;
      double maxLossProfit = -100; //-15eurusd -45usdchf
      
      MqlTick last_tick;
                             
      if (currentTick==0)
      {
         if(SymbolInfoTick(Symbol(),last_tick))
         {
            Print(last_tick.time,": Bid = ",last_tick.bid, " Ask = ",last_tick.ask,"  Volume = ",last_tick.volume);
            
            initialBuyPrice = last_tick.ask; // il faudra revendre quand le prix devient plus haut que a
            initialSellPrice = last_tick.bid; // il faudra acheter quand le prix devient plus bas que a

            balanceBeforeTrade = getAccountBalance();
            Print("Current Balance before trade = " + balanceBeforeTrade);
                       
            if (previousActionIsBuySellWithoutProfit == true)
            {
               Print("currentTick=0 and previous action is Buy Sell without profit so I SELL");
               trade.Sell(quantity);
            }
            else
            {
               Print("currentTick=0 and previous action is Sell Buy without profit so I BUY");
               trade.Buy(quantity);
            }
         }
         else Print("SymbolInfoTick() failed, error = ",GetLastError());
  
      }
      
      
      if(SymbolInfoTick(Symbol(),last_tick))
      {
         currentSellPrice = last_tick.bid;         
         currentBuyPrice = last_tick.ask;         
      }
      
      currentProfit = ca.Equity() - balanceBeforeTrade;
      
      if ((previousActionIsBuySellWithoutProfit == false) && (currentSellPrice > initialBuyPrice))
      {  
         Print("Current sell price " + currentSellPrice + " is greater than price bought " + initialBuyPrice + " so I SELL");
         trade.Sell(quantity);                  
         currentTick=0;
         
         balanceAfterTrade = getAccountBalance();         
         double balanceDiff = balanceAfterTrade - balanceBeforeTrade;
         totalProfit = totalProfit + balanceDiff;                  
         Print("totalProfit=" + totalProfit);
      }
      else if ((previousActionIsBuySellWithoutProfit == true) && (currentBuyPrice < initialSellPrice))
      {
         Print("Current buy price " + currentBuyPrice + " is lesser than price sold " + initialSellPrice + " so I BUY");
         trade.Buy(quantity);                  
         currentTick=0;
         
         balanceAfterTrade = getAccountBalance();         
         double balanceDiff = balanceAfterTrade - balanceBeforeTrade;
         totalProfit = totalProfit + balanceDiff;                  
         Print("totalProfit=" + totalProfit);
      }
      else
      {
         currentTick++;
      }
            
      if ( (currentTick>=maxTickBeforeForceSell) || (currentProfit<maxLossProfit) )
      {
         Print("currentProfit = " + currentProfit + " maxLossProfit = " + maxLossProfit);

         if (previousActionIsBuySellWithoutProfit == true)
         {
            Print("Max tick reached or max profit loss reached, forced buy");
            trade.Buy(quantity);
         }
         else
         {
            Print("Max tick reached or max profit loss reached, forced sell");
            trade.Sell(quantity);
         }
         currentTick = 0;
         
         balanceAfterTrade = getAccountBalance();         
         double balanceDiff = balanceAfterTrade - balanceBeforeTrade;
         totalProfit = totalProfit + balanceDiff;                  
         Print("totalProfit=" + totalProfit);
         
         previousActionIsBuySellWithoutProfit = true; // next action is to sell if buy before or buy if sell before
      }
      
  }
  
  double getAccountBalance()
  {
      return ca.Balance();
  }
  
  double getBuyPrice()
  {
         MqlTick last_tick;
         double currentbid = 0;
         if(SymbolInfoTick(Symbol(),last_tick))
         {
            //Print(last_tick.time,": Bid = ",last_tick.bid, " Ask = ",last_tick.ask,"  Volume = ",last_tick.volume);
            currentbid = last_tick.bid;            
         }
         //else Print("SymbolInfoTick() failed, error = ",GetLastError());

         return currentbid;
  }
  
  double getSellPrice()
  {
         MqlTick last_tick;
         double currentask = 0;
         if(SymbolInfoTick(Symbol(),last_tick))
         {
            //Print(last_tick.time,": Bid = ",last_tick.bid, " Ask = ",last_tick.ask,"  Volume = ",last_tick.volume);
            currentask = last_tick.ask;            
         }
         //else Print("SymbolInfoTick() failed, error = ",GetLastError());

         return currentask;
  }
  
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   Print("OnTimer");
  }
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction& trans,
                        const MqlTradeRequest& request,
                        const MqlTradeResult& result)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
   double ret=0.0;
//---

//---
   return(ret);
  }
//+------------------------------------------------------------------+
//| TesterInit function                                              |
//+------------------------------------------------------------------+
void OnTesterInit()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TesterPass function                                              |
//+------------------------------------------------------------------+
void OnTesterPass()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TesterDeinit function                                            |
//+------------------------------------------------------------------+
void OnTesterDeinit()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| BookEvent function                                               |
//+------------------------------------------------------------------+
void OnBookEvent(const string &symbol)
  {
//---
   
  }
//+------------------------------------------------------------------+
